; about code for the Wall
; sets up the 'about' window
; v  1.02	24.06.2016 removed references to JMS.
; v. 1.01	1994 Jul 19 initial version
; copyright (C) W. Lenerz 2000-2016, see the accompanying licence_txt file.
;
; this window is set up to be in the middle of the main window
	section about

	include dev1_asm_wall_includes
	include dev1_asm_incl_keys_wman_vectors
	include dev1_asm_incl_keys_k

	xdef	about
	xdef	aboutdef	; this window defn, for init
	xdef	wonlost

	xref	win2def
	xref	cross
	xref	wolf_sprt
	xref.l	version
	xref	gu_achp 	; get common heap (gu)
	xref	gu_rchp
	xref	sound
	xref	jname		; (init)
	xref	sp4_clown
	xref	sp4_clowntriste
	xref	inf1_cl
	xref	inf1_txt
	xref	won_text
	xref	lost_text



; on entry,			exit
;
; a4 pointer to our window defn same
; A5 contains the wman vectors	same

abregs	reg	d1-d4/a0-a4

wonlost movem.l abregs,-(a7)
	move.w	d0,-(a7)
	jsr	sound
	move.w	(a7)+,d0
	subq.w	#2,d0
	bne.s	won
	lea	sp4_clowntriste,a2
	move.l	a2,d0
	lea	inf1_cl,a2
	sub.l	a2,d0
	move.w	d0,(a2)
	lea	lost_text,a2
	move.l	a2,d0
	lea	inf1_txt,a2
	sub.l	a2,d0
	move.w	d0,(a2)
	bra.s	lostwon

won	lea	sp4_clown,a2
	move.l	a2,d0
	lea	inf1_cl,a2
	sub.l	a2,d0
	move.w	d0,(a2)
	lea	won_text,a2
	move.l	a2,d0
	lea	inf1_txt,a2
	sub.l	a2,d0
	move.w	d0,(a2)
lostwon lea	win2def,a2
	bra.s	about2

about	movem.l abregs,-(a7)
	lea	aboutdef,a2
about2	move.l	#1000,d0
	jsr	gu_achp
	bne.s	about_out
	moveq	#0,d1
	move.l	8(a4),a3	; a3 = (old) channel id
	move.l	$20(a4),d4	; x,y size of window
	sub.l	(a2),d4 	; - x,y size of about window=
	swap	d4		; now make x, y origins
	lsr.w	#1,d4
	swap	d4
	lsr.w	#1,d4		; now each is just half= origins
	add.l	$24(a4),d4	; now absolute origins
	add.l	4(a2),d4	; + false origin of window
	move.l	a0,a4		; point to my space
	move.l	a3,a0		; the channel id into a0
	lea	900(a4),a1	;
	move.w	#0,$40(a1)	; new status area
	move.l	a2,a3		; this is the window definition
	jsr	wm.setup(a5)	; set up this window
	move.l	d4,d1

	jsr	wm.pulld(a5)	; pull down
	jsr	wm.wdraw(a5)	; draw
rd_help jsr	wm.rptr(a5)	; read pointer until click
rd_ok	jsr	wm.unset(a5)
	move.l	8(a4),a0
	moveq	#2,d0
	trap	#2
	move.l	a4,a0
	jsr	gu_rchp
about_out
	movem.l       (a7)+,abregs
	rts


abtwin_act moveq	 #-1,d0
	rts
******************************************************************************
*
* the "about" window defn
*
******************************************************************************

rays	equ	14
abxsize equ	204
abx2	equ	abxsize/2
abysize equ	82
abtitobj	equ	8*12		; LENGTH of title, this changes!
abtitwin	equ	abtitobj+4
abtemp1 EQU	abxsize-abtitwin
aboutdef dc.w  abxsize			;default window x size
	 dc.w  abysize			;		    y size
	 dc.w  16			;initial pointer x position
	 dc.w  abysize-10		;	     y position
	 dc.b  $00			;MSbit clear to clear window
	 dc.b  2			;shadow depth
	 dc.w  1			;border width
	 dc.w  7			;border colour
	 dc.w  0			;paper colour
	 dc.w  cross-*			;pointer to pointer sprite

; menu item attributes
	 dc.w  1			;current item border width
	 dc.w  0			;	  border colour

; menu item unavailable:
	 dc.w  7			;background colour
	 dc.w  4			;text object ink colour
	 dc.w  0			;pointer to blob for pattern
	 dc.w  0			;pointer to pattern for blob
; menu item available  :
	 dc.w  7			;background colour
	 dc.w  0			;text object ink colour
	 dc.w  0			;pointer to blob for pattern
	 dc.w  0			;pointer to pattern for blob
; menu item selected   :
	 dc.w  4			;background colour
	 dc.w  0			;text object ink colour
	 dc.w  0			;pointer to blob for pattern
	 dc.w  0			;pointer to pattern for blob

;
	 dc.w  0			;pointer to help window
;base of repeated part of window definition
	 dc.w  abxsize			;x (min.) size for this layout
	 dc.w  abysize			;y (min.) size for this layout
;pointers to definition lists :
	 dc.w  abinfo-* 		;information sub-windows
	 dc.w  abloose-*		; loose items
	 dc.w  0			;application sub-windows
;
	 dc.w  -1			;end flag
;
;Information sub-window definition list :
;========================================

;
;Information sub-window No. 0  (menue leiste)
abinfo	 dc.w  abxsize			;sub-window x size
	 dc.w  rays			;sub-window y size
	 dc.w  0			;sub-window x origin
	 dc.w  0			;sub-window y origin
	 dc.b  $00			;MSbit clear to clear window
	 dc.b  0			;shadow depth
	 dc.w  0			;border width
abinfo1  dc.w  7			;border colour
	 dc.w  82			;paper colour
	 dc.w  0			;pointer to information object list

;Information sub-window No. 1 bis (big info subwindow)
	 dc.w  abxsize-8		;sub-window x size
	 dc.w  abysize-16		;sub-window y size
	 dc.w  4			;sub-window x origin
	 dc.w  14			;sub-window y origin
	 dc.b  $00			;MSbit clear to clear window
	 dc.b  0			;shadow depth
	 dc.w  1			;border width
	 dc.w  2			;border colour
	 dc.w  0			;paper colour
	 dc.w about_obj-*		;pointer to information object list ;

;
; info window with title (n2)
	 dc.w  abtitwin 		; hit area   x size
	 dc.w  11			;	  y size
	 dc.w  abtemp1/2		;	  x origin
	 dc.w  2			;	  y origin
	 dc.b  $00			;MSbit clear to clear window
	 dc.b  0			;shadow depth
	 dc.w  0			;border width
	 dc.w  7			;border colour
	 dc.w  0			;paper colour
	 dc.w  fifi2_obj-*		;pointer to information object list
;
	dc.w	-1
;

fifi2_obj dc.w	abtitobj		;object x size
	 dc.w  10			;     y size
	 dc.w  2			;     x origin
	 dc.w  1			;     y origin
	 dc.b  0			;object type
	 dc.b  0			;spare
	 dc.w  7			;text ink colour
	 dc.b  2			;text character x size
	 dc.b  0			;text character y size
	 dc.w  jname-*			;pointer to object

	 dc.w  -1

; object list for inner info window
about_obj  dc.w  52			;object x size
	 dc.w  24			;     y size
	 dc.w  abxsize-8-60		;	      x origin
	 dc.w  20			;	      y origin
	 dc.b  sprite			;object type
	 dc.b  0			;spare
	 dc.w  0			; text ink colour
	 dc.b  0			;text character x size
	 dc.b  0			;text character y size
	 dc.w  wolf_sprt-*		;pointer to object


	 dc.w  72			;object x size
	 dc.w  10			;     y size
	 dc.w  abx2-40			;     x origin
	 dc.w  4			;     y origin
	 dc.b  text			;object type
	 dc.b  0			;spare
	 dc.w  7			;text ink colour
	 dc.b  0			;text character x size
	 dc.b  0			;text character y size
	 dc.w  vers-*			;pointer to object

	 dc.w  100			;object x size
	 dc.w  20			;     y size
	 dc.w  0			;     x origin
	 dc.w  22			;     y origin
	 dc.b  text			;object type
	 dc.b  0			;spare
	 dc.w  7			;text ink colour
	 dc.b  0			;text character x size
	 dc.b  0			;text character y size
	 dc.w  copy-*			;pointer to object

	 dc.w	   -1

; loose item
; ----------------------------------------------------------------------
abloose dc.w  abxsize-12		;hit area   x size
	 dc.w  10			;	  y size
	 dc.w  6			;	  x origin
	 dc.w  abysize-14		;	  y origin
	 dc.b  0			;object x justification
	 dc.b  0			;object y justification
	 dc.b  text			;object type
	 dc.b  k.cancel 		;selection keystroke
	 dc.w  ob_do-*			;pointer to object
	 dc.w  0			;item number
	 dc.w  abtwin_act-*		;pointer to action routine
	 dc.w	   -1

ob_do	dc.w	SUP-*-2
	DC.B	'SUPER!'
sup


copy	dc.w	copy2-*-2
	dc.b	' Copyright  2000-2016',$a,' Wolfgang Lenerz'
copy2

vers	dc.w	12
	dc.w	'Version '
	dc.l	version
	end
