; the Wall : applic wdw drawing routine
; applic wdw hit routine
; v. 1.02 -    24.06.2016  use block to delete old sprite in hit routine
; v. 1.01 -    2000 jun 20 09:59:53

; copyright (C) W. Lenerz 2000-2016, see the accompanying licence_txt file.

	section applic
	include dev1_asm_wall_includes

	xdef	app_draw
	xdef	app_hit
	xdef	redraw
; sprites
	xref	sp4_amblack
	xref	sp4_blkarrow
	xref	sp4_arrowgr
	xref	sp4_amblkred
	xref	sp4_rose
	xref	sp4_vert
	xref	sp4_amblacksm
	xref	sp4_blkarrowsm
	xref	sp4_arrowgrsm
	xref	sp4_amblkredsm
	xref	sp4_rosesm
	xref	sp4_vertsm
	xref	sp4_white

	xdef	spriteblk
	xdef	sprtblk2

	xref	chk_move		; (chkmove) checks whether this was a legit/successful move
	xref	chk_poss		; checks whether a further move is possible
	xref	ssprite 		; (init) redraws 'the wall' sprite
	xref	sound			; (sound) dooda
	xref	wonlost 		; (about)
; application wdw drawing routine - draw the entire appsub wdw
; on entry, the wdw has been set to my appsub
; each tile is a sprite
myregs	reg	a1-a2/d1-d7
app_draw	movem.l myregs,-(a7)
	moveq	#$20,d0
	moveq	#-1,d3			;
	trap	#3			; clear wdw entirely
	move.l	current(a4),a2		; pointer to current state of game
	moveq	#yoffset,d4		; row counter (y)
	moveq	#0,d6
bigloop moveq	#xoffset,d5		; col counter (x)
inloop	move.b	(a2)+,d6		; get one tile
	beq.s	dontdraw		; there is none! ->...
	lea	spriteblk,a1		; table of ptrs to sprites
	add.l	(a1),a1 		; point to sprites now...

	lsl.w	#2,d6			; *4, lword sized table
	add.w	d6,a1
	add.l	(a1),a1 		; point to sprite now
all2	move.w	d5,d1			; x position
	swap	d1
	move.w	d4,d1			; y position
	moveq	#$76,d0
	trap	#3			; write sprite now
	tst.l	d0
	bne.s	ad_out			; ooops?!
dontdraw
	move.w	spr_x(a4),d0
	add.w	d0,d5			; on to next column
	mulu	#nbr_cols,d0
	add.w	#xoffset,d0
	cmp.w	d0,d5			; was it last column?
	bne.s	inloop			; no, so do next->...
	move.w	spr_y(a4),d0
	add.w	d0,d4			; next row
	mulu	#nbr_rows,d0
	add.w	#yoffset,d0
	cmp.w	d0,d4			; was it last row?
	bne.s	bigloop 		; no, so do next ->...
	moveq	#0,d0			; no error
ad_out	movem.l (a7)+,myregs
	rts

; application subwdw hit routine
; this is called: whenever the ptr moves in wdw through cursor keys
; at each read ptr timeout
; when hitting/doing wdw

apphregs reg	d1/d3/d5-d7/a0-a5
app_hit movem.l apphregs,-(a7)		; save these regs
	cmp.l	#-1,d0			; timeout?
	beq.s	rdw			; yes, just redraw sprite
	subq.w	#1,d2			; hit?
	beq.s	ttest			; ... yes
	subq.w	#1,d2			; do?
	bne.s	apph_out2		; ... no (simple ptr move), do nothing

ttest	sub.l	$24(a4),d1		; make ptr rel to wdw
	sub.l	4(a3),d1		; and now rel to appsub wdw
	moveq	#0,d0
	move.w	d1,d0			; d0 = y pointerpos (rows)
	sub.w	#yoffset,d0
	bmi.s	yminus			; what?
	divs.w	spr_y(a4),d0		; now we get the row nbr
	bra.s	x
yminus	moveq	#0,d0			; if minus, row 0
x	move.w	#0,d1			; now the columns
	swap	d1
	sub.w	#xoffset,d1
	bmi.s	xminus
	divs.w	spr_x(a4),d1
	bra.s	all
xminus	moveq	#0,d1
all	jsr	chk_move		; check whether something should move
	beq.s	apph_out2		; no->...
	move.l	current(a4),a2		; current state of board
	move.l	a2,a3			; keep
	sub.l	#tottiles,a3		; point to previous state of board
	bsr.s	redraw			; redraw board now
	bsr	chk_poss		; are any further moves possible?
;	 trap	 #14
;	 moveq	 #0,d0
;	 jsr	 sound
;
;	 moveq	 #1,d0
;	 jsr	 sound
;
;	 moveq	 #2,d0
;	 jsr	 sound
;
;	 moveq	 #3,d0
;	 jsr	 sound
					      
	beq.s	rdw			; yes->...
	blt.s	won			; no, because we won game ->...
	moveq	#2,d0			; no, because we lost game
	bra.s	ssndv
won	moveq	#3,d0
ssndv	jsr	wonlost 		; make sound  & show won/lost wdw
rdw	jsr	ssprite 		; redraw 'the wall' sprite
apph_out2
	movem.l (a7)+,apphregs		; get regs back
apph_out
	moveq	#0,d4			; no event
	move.l	d4,d0			; and no error
	rts


; this redraws the board, compares with previous move to redraw only
; those tiles that have changed
; this is done for each column in each row
; on entry:
; a2 = new board
; a3 = old board


redraw	moveq	#-1,d2			; no reset
	moveq	#0,d1			; app sub nbr
	jsr	$60(a5) 		; set wdw to my appsub wdw
	moveq	#yoffset,d4		; row counter (y)
	moveq	#0,d6
	moveq	#-1,d3			; timeout
bigloop2
	moveq	#xoffset,d5		; col counter (x)
inloop2 move.b	(a2)+,d6		; new state of board
	move.b	(a3)+,d7		; old state of board
	cmp.b	d7,d6			; are they the same?
	beq.s	dontdrw 		; yes, no need to draw anything->...
	lea	spriteblk,a1		; ptr to ptr to sprite block
	add.l	(a1),a1
	lsl.w	#2,d7			; *4, lword sized table
	add.w	d7,a1
	add.l	(a1),a1 		; point to sprite now
	move.w	d5,d2			; x position
	swap	d2
	move.w	d4,d2			; d1.h = x pos, d1.low = y position
;	 move.l  4(a1),d1		 ; size of sprite
; new
	subq.l	#8,a7

	move.l	4(a1),(a7)
	move.l	a7,a1
	move.l	d2,4(a1)		; position
;	 move.l  d1,(a1)		 ; size

	clr.l	d1			; block colour = black
	moveq	#$2e,d0
	trap	#3
	addq.l	#8,a7
	lea	spriteblk,a1
	add.l	(a1),a1
	lsl.w	#2,d6			; *4, lword sized table
	add.w	d6,a1
	add.l	(a1),a1 		; point to new sprite now
	move.l	d2,d1			; position
	moveq	#$76,d0
	trap	#3			; write sprite (sprite is xored)
dontdrw move.w	spr_x(a4),d0		; offset to next sprite on screen
	add.w	d0,d5			; on to next column
	mulu	#nbr_cols,d0
	add.w	#xoffset,d0
	cmp.w	d0,d5			; was it last column?
	bne.s	inloop2 		; no, try this column then ->...
	move.w	spr_y(a4),d0
	add.w	d0,d4			; next row
	mulu	#nbr_rows,d0
	add.w	#yoffset,d0
	cmp.w	d0,d4			; was it last row?
	bne.s	bigloop2		; no, so try all cols of this row
	rts				; it was last column, last row, done

; pointer to sprites

spriteblk
	dc.l  sprtblk1-*		; this is changed dynamically at runtime!

sprtblk1
	dc.l	sp4_white-*		; big sprites
	dc.l	sp4_amblack-*
	dc.l	sp4_blkarrow-*
	dc.l	sp4_arrowgr-*
	dc.l	sp4_amblkred-*
	dc.l	sp4_rose-*
	dc.l	sp4_vert-*
sprtblk2
	dc.l	sp4_white-*		; smaller sprites
	dc.l	sp4_amblacksm-*
	dc.l	sp4_blkarrowsm-*
	dc.l	sp4_arrowgrsm-*
	dc.l	sp4_amblkredsm-*
	dc.l	sp4_rosesm-*
	DC.L	sp4_vertsm-*

	END
