; item action routines for the Wall
; v. 1.02	+ and - items make a sound
; v. 1.01		2003 Dec 01 06:58:45
; copyright (C) W. Lenerz 2000-2016, see the accompanying licence_txt file.


	section action
	include dev1_asm_wall_includes
	include dev8_keys_wman
	include dev8_keys_wwork

; item action routines contained herein
	xdef	act_esc 	; esc item action routine
	xdef	act_zzz 	; zzz item action routine
	xdef	act_move
	xdef	act_new
	xdef	act_back
	xdef	act_plus
	xdef	act_minus


	xdef	mk_btn		; true make button routine
	xdef	chan		; 'con'




	xref	do_butn 	; menu extension do button
	xref	btncol		; (.b) contains button colourways
	xref	jname		; (init) title string
	xref	new_game	; (init) sets up board again
	xref	redraw		; (applic) redraws board
	xref	sound

;----------------------------------------------------------------
; act_esc:  routine called by esc item (quits job definitely)

act_esc moveq	#-1,d1
	moveq	#0,d3
	moveq	#5,d0
	trap	#1
				      
;---------------------------------------------------------------------------
; act_zzz: makes a button (sleep item)

act_zzz moveq	#btn_err,d0
	rts			; gets out of the rd.ptr loop

mk_btn	move.l	(a4),a1
	move.b	#1,$40+it_zzz(a1)
	jsr	wm.unset(a5)	; unset main window, this also puts
	lea	btnstat(a4),a1	; the channel id into a0
	move.w	#0,$40(a1)
	moveq	#2,d0
	trap	#2
	lea	btncol,a1
	moveq	#0,d3
	move.b	(a1),d3
	moveq	#-1,d2
	lea	jname,a1
	bsr	do_butn
	lea	chan,a0
	moveq	#1,d0
	moveq	#-1,d1
	moveq	#0,d3
	trap	#2
	move.l	a0,8(a4)
	lea	status(a4),a1
	move.l	$20(a1),d1
	sub.l	$24(a4),d1
	move.l	d1,$24(a4)
	move.l	$20(a1),d1
	jsr	wm.prpos(a5)
	jmp	wm.wdraw(a5)	; draw & return

					  
;-----------------------------------------------------------------------
; act_move: routine called when move window item clicked

act_move
	bset	#3,$15(a1)		; show move
	move.b	#1,it_move+$40(a1)
	jsr	wm.chwin(a5)		; do move
	bra.s	rdrw_its		; redraw items

					  
;------------------------------------------------------------------
; act_back
;-----------------------------------------------
backregs	reg	d1-d7/a1-a3
act_back	move.b	#1,it_new+$40(a1)
	movem.l backregs,-(a7)
	move.l	current(a4),a3
	cmp.l	moves(a4),a3
	beq.s	none
	move.l	a3,a2
	sub.l	#tottiles,a2
	move.l	a2,current(a4)	; new current status
	move.l	a2,a3
	add.l	#tottiles,a3	; point to last row
	move.l	a3,a1
	sub.l	#nbr_cols,a1
	moveq	#0,d0
	moveq	#nbr_cols-1,d1
fnd_end move.b	(a1)+,d2
	beq.s	rd
	addq.w	#1,d0		; find last col
	dbf	d1,fnd_end
rd	move.w	d0,lastcol(a4)	; possiblenew last column
	jsr	redraw		; redraw

none	movem.l (a7)+,backregs
rdrw_its	moveq	#-1,d3
	jsr	$2c(a5) 	; redraw items
	moveq	#0,d3
	move.w	timeout(a4),d3
	moveq	#0,d4
	moveq	#0,d0
	rts

;------------------------------------------------------------
; act plus & minus
;------------------------------------------------------------
act_plus
	moveq	#4,d0
	bsr	sound
	move.b	#1,it_plus+$40(a1)
	move.w	diff(a4),d0		; old difficulty
	cmp.b	#2,d0
	beq.s	rdrw_its		; only three levels
	addq.w	#1,d0
	move.w	d0,diff(a4)
	bra.s	act_new

act_minus
	moveq	#5,d0
	bsr	sound
	move.b	#1,it_minus+$40(a1)
	move.w	diff(a4),d0
	beq.s	rdrw_its
	subq.w	#1,d0
	move.w	d0,diff(a4)

	; fall through
	

;--------------------------------------------------------------
; act_new
;--------------------------------------------------------------

act_new move.b	#1,it_new+$40(a1)
	bsr	new_game		; new game
ret	moveq	#0,d3
	move.w	timeout(a4),d3
	jmp	$1c(a5) 	; redraw wdw
	
bfr_name
	dc.w	12
	dc.w	'Button Frame'
chan	dc.w	3,'CON'
 


	END
